package world;
import java.util.*;
import java.awt.Rectangle;

//
//  do not modify!
//
public class World {
	
	public List<Robot> robots = new ArrayList<Robot>();
	public List<Item> items = new ArrayList<Item>();
	public List<Mark> marks = new ArrayList<Mark>();

	public Rectangle bbox = new Rectangle(0,0,640, 480);
	
	public Robot get_robot(){
		return robots.get(0);
	}
	public Mark get_mark(){
		return marks.get(0);
	}
	public Item get_item(){
		return items.get(0);
	}
	
	
	
	

	
	
	
	
	
	public int N_ROBOTS = 1;
	public int N_ITEMS = 1;
	public int N_MARKS = 1;
	static {
		world = new World();
	}
	static public World world;
	World() {
		initialize_layout();
		Simulator.init(this);
		
	}
	
	public void initialize_layout(){
		robots = new ArrayList<Robot>();
		for(int i=0; i<N_ROBOTS; i++){
			double x = Math.random()*500+50;
			double y = Math.random()*400+50;
			Vector2D position = new Vector2D(x, y);
			Vector2D orientation = new Vector2D(Math.random()*2-1,Math.random()*2-1);
			orientation.normalize();
			
			Robot robot = new Robot(position, orientation);
			robots.add(robot);
			robot.id = i;
			robot.setName("robot"+i);
			
			//robot_is_locked.put(robot, Boolean.FALSE);
		}
		
		items = new ArrayList<Item>();
		for(int i=0; i<N_ITEMS; i++){
			double x = Math.random()*500+50;
			double y = Math.random()*400+50;
			Vector2D position = new Vector2D(x, y);
			Vector2D orientation = new Vector2D(Math.random()*2-1,Math.random()*2-1);
			orientation.normalize();

			Item item = new Item(position, orientation);
			items.add(item);
			item.id = i;
			item.setName("item"+i);
		}
		marks = new ArrayList<Mark>();
		for(int i=0; i<N_MARKS; i++){
			double x = Math.random()*500+50;
			double y = Math.random()*400+50;
			Vector2D position = new Vector2D(x, y);
			Vector2D orientation = new Vector2D(Math.random()*2-1,Math.random()*2-1);
			orientation.normalize();

			Mark mark = new Mark(position);
			marks.add(mark);
			mark.id = i;
			mark.setName("mark"+i);
		}
		

	
	}
	
	
	public List<Entity> entities(){
		List entities = new ArrayList();
		entities.addAll(robots);
		entities.addAll(items);
		return entities;
	}
	
	
	
	public Entity pick_entity(Vector2D v){
		List<Entity> entities = new ArrayList<Entity>();
		entities.addAll(world.robots);
		entities.addAll(world.items);
		entities.addAll(world.marks);
		for(Entity entity : entities){
			if (Vector2D.distance(entity.position, v)< entity.r)
				return entity;
		}
		return null;
	}




}

